#!/bin/bash

numserv=`/bin/hostname|/bin/sed 's/[^12]//g'`
if [ 0$numserv -eq 1 ];then
    servloc='master1'
    servrem='master2'
elif [ 0$numserv -eq 2 ];then
    servloc='master2'
    servrem='master1'
else
    echo "No se detecto el servidor master"
    exit
fi;

echo "Ejecutando en $servloc, voy a copiar la base a $servrem"
echo -n "Ingrese el password del root de la base de datos: "
read -s passwordroot
echo

#bajo el cron para que no se desconecten los usuarios
service crond stop
#bajo los servicios remotos
ssh -p 9559 root@$servrem "/sbin/service radiusd stop;/sbin/service \$([ -f /usr/lib/systemd/system/mariadb.service ] && echo mariadb || echo mysqld) stop;service crond stop;/bin/rm -rf /var/lib/mysql.bak; /bin/mv /var/lib/mysql /var/lib/mysql.bak"
#borro el backup para que no se pisen
/bin/rm -rf /var/lib/mysql.bak
#bajo el mysql para copiar archivos limpios
/sbin/service $([ -f /usr/lib/systemd/system/mariadb.service ] && echo mariadb || echo mysqld) stop
#borro todo lo referente a la sincronizacion
/bin/rm -rf /var/lib/mysql/master* /var/lib/mysql/*relay* /var/lib/mysql/aria* /var/lib/mysql/mysql_upgrade_info
#me guardo una copia para copiar al servidor remoto
/bin/cp -pr /var/lib/mysql /var/lib/mysql.bak
#levanto el mysql, para minimizar el tiempo de down
/sbin/service $([ -f /usr/lib/systemd/system/mariadb.service ] && echo mariadb || echo mysqld) start
#copio el backup al servidor remoto
scp -pr -P 9559 /var/lib/mysql.bak root@$servrem:/var/lib/mysql
#levanto el mysql y configuro la replicacion remota
ssh -p 9559 root@$servrem "/bin/chown -R mysql:mysql /var/lib/mysql;/sbin/service \$([ -f /usr/lib/systemd/system/mariadb.service ] && echo mariadb || echo mysqld) start;/bin/echo \"CHANGE MASTER TO MASTER_HOST = '$servloc', MASTER_PORT = 3306, MASTER_USER = 'slv_repl_user', MASTER_PASSWORD = '%%replpass%%';START SLAVE;\"  | mysql -uroot -p$passwordroot ; /sbin/service radiusd start;service crond start"
#configuro el mysql local
/bin/echo "CHANGE MASTER TO MASTER_HOST = '$servrem', MASTER_PORT = 3306, MASTER_USER = 'slv_repl_user', MASTER_PASSWORD = '%%replpass%%';START SLAVE;"  | mysql -uroot -p$passwordroot
/sbin/service crond start
